#include <cstdio>
#include <cstdlib>
#include <cmath>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/*
** gbN{[p֐̐錾
*/
#include "trackball.h"

/*
** `f[^
*/
#include "Obj.h"
Obj *data;

/*
** _̋
*/
static double offset = -200.0;

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 };  /* ʒu */

/*
** eNX`
*/
#define TEXWIDTH  256                      /* eNX`̕@@@ */
#define TEXHEIGHT 256                      /* eNX`̍@@ */
static const char texture1[] = "toon.raw"; /* eNX`t@C */

/*
** 
*/
static void init(void)
{
  /* eNX`̓ǂݍ݂Ɏgz */
  GLubyte texture[TEXHEIGHT][TEXWIDTH][3];
  FILE *fp;
  
  /* eNX`摜̓ǂݍ */
  if ((fp = fopen(texture1, "rb")) != NULL) {
    fread(texture, sizeof texture, 1, fp);
    fclose(fp);
  }
  else {
    perror(texture1);
  }

  /* eNX`摜̓oCgPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
  /* eNX`̊蓖 */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TEXWIDTH, TEXHEIGHT, 0,
    GL_RGB, GL_UNSIGNED_BYTE, texture);
    
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  /* eNX`̌JԂ̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glDisable(GL_LIGHTING);

  /* `f[^IuWFNg̍쐬 */
  data = new Obj;

  /* `f[^̓ǂݍ */
  data->load("bunny.obj");
}

/*
** V[̕`
*/
void scene(void)
{
  GLfloat eyepos[] = { 0.0f, 0.0f, (GLfloat)-offset, 1.0f };
  GLfloat lpos[4], epos[4];
  const double *rt;
  int i, j;

  /*
  ** ]̕ϊso
  */
  rt = trackballRotation();

  /*
  ** 𕨑̂̉]Ƌtɉ]i]s̓]usj
  */
  for (i = 0; i < 4; ++i) {
    lpos[i] = 0.0;
    for (j = 0; j < 4; ++j) {
      lpos[i] += lightpos[j] * rt[i * 4 + j];
    }
  }

  /*
  ** _𕨑̂̉]Ƌtɉ]i]s̓]usj
  */
  for (i = 0; i < 4; ++i) {
    epos[i] = 0.0;
    for (j = 0; j < 4; ++j) {
      epos[i] += eyepos[j] * rt[i * 4 + j];
    }
  }

  data->calcTexCoord(lpos, epos);
  data->draw();
}

/****************************
** GLUT ̃R[obN֐ **
****************************/

static void display(void)
{
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, offset);
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 500.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      glutIdleFunc(0);
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case '+':
    offset += 10.0;
    glutPostRedisplay();
    break;
  case '-':
    offset -= 10.0;
    glutPostRedisplay();
    break;
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
